def dumpAstTree(node, depth=""):
	s = depth + "(" + node.type
	if hasattr(node, "attr"):
		s = s + ", " + str(node.attr) + ")"
	else:
		s = s + ")"
	print s
	for n in node:
		dumpAstTree(n, depth + "  ")
	
	

#########################################
def dumpTree(t):
	for func in t:
		dumpFunc(func)

def dumpFunc(func):
	print "Function: " + func['name']
	t = makeBlanks(1)
	print t + "Input Paramaters:"
	for i in func['inputParams']:
		print makeBlanks(2)+str(i)
	print t + "Options:"
	for i in func['options']:
		print makeBlanks(2)+str(i)
	print t + "Functions Child Objects:"
	for i in func['objects']:
		dumpObject( 2, i)

def dumpObject(depth, obj):
	t = makeBlanks(depth)
	print t +  "Object:"
	for i in obj.keys():
		if i == "options":
			print makeBlanks(depth+1)+"Options:"
			opts = obj[i]
			for o in opts.keys():
				print makeBlanks(depth+2)+o+" : "+str(opts[o])
		else:
			if i == 'objects':
				print makeBlanks(depth+1)+"Child Objects:"
				for o in obj[i]:
					dumpObject(depth+2, o)
			else:
				print makeBlanks(depth+1)+i+" : "+str(obj[i])


def dumpSequence(sequence, label=""):
	print label
	for s in sequence:
		print str(s)
	print

	
	
def makeBlanks(depth):
	r = ""
	for i in xrange(0, depth, 1):
		r = r + "     "
	return r


